      PROGRAM ORG__MAIN___
      INCLUDE 'mpif.h'
      EXTERNAL ORG___MAIN___
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ierrX0
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      CALL mpi_init(ierrX0)
      CALL mpi_comm_rank(MPI_COMM_WORLD,ORG_RANK,ierrX0)
      CALL mpi_comm_size(MPI_COMM_WORLD,ORG_SIZE,ierrX0)
      CALL ORG___MAIN___()
      CALL mpi_finalize(ierrX0)
      END PROGRAM
      SUBROUTINE ORG___MAIN___()
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      REAL(KIND=4):: ttarget
      PARAMETER (ttarget=60.0e0)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      REAL(KIND=4):: time0(1:2)
      REAL(KIND=4):: time1(1:2)
      EXTERNAL initmt
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: cpu0
      EXTERNAL gdtime
      REAL(KIND=4):: gdtime
      EXTERNAL jacobi
      REAL(KIND=4):: gosa
      REAL(KIND=4):: cpu1
      REAL(KIND=4):: cpu
      REAL(KIND=4):: flop
      INTRINSIC real
      REAL(KIND=4):: xmflops2
      INTRINSIC ifix
      REAL(KIND=4):: score
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: wrk2(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: wrk1(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: bnd(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: c(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: b(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: p(0:256,0:128,-1:128/ORG_SIZE+1)
      REAL(KIND=4):: a(0:256,0:128,0:128/ORG_SIZE,0:3)
      INTEGER(KIND=4):: ierrX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      omega = 0.8e0
      imax = 256
      jmax = 128
      kmax = 128
      CALL initmt(p,a,b,c,bnd,wrk1,wrk2)
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' mimax=',257,' mjmax=',1&
     &29,' mkmax=',129
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' imax=',imax,' jmax=',jm&
     &ax,' kmax=',kmax
      nn = 3
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Start rehearsal measure&
     &ment process.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Measure the performance&
     & in 3 times.'
      cpu0 = gdtime(time0)
      CALL jacobi(p,a,b,c,bnd,wrk1,wrk2,nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop/cpu*(1.0E-6)
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) '  MFLOPS:',xmflops2,'  t&
     &ime(s):',cpu,gosa
      nn = ifix(ttarget/(cpu/(3.0e0)))
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Now, start the actual me&
     &asurement process.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'The loop will be excuted&
     & in',nn,' times.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'This will take about one&
     & minute.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Wait for a while.'
      cpu0 = gdtime(time0)
      CALL jacobi(p,a,b,c,bnd,wrk1,wrk2,nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop*(1.0E-6)/cpu
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Loop executed for ',nn,&
     &' times'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Gosa :',gosa
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' MFLOPS:',xmflops2,'  ti&
     &me(s):',cpu
      score = xmflops2/(82.84e0)
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Score based on Pentium &
     &III 600MHz :',score
      RETURN
      END SUBROUTINE
      SUBROUTINE initmt(p,a,b,c,bnd,wrk1,wrk2)
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: k
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: i
      INTRINSIC float
      INTRINSIC max
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: wrk2(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: wrk1(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: bnd(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: c(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: b(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: a(0:256,0:128,0:128/ORG_SIZE,0:3)
      REAL(KIND=4):: p(0:256,0:128,-1:128/ORG_SIZE+1)
      INTRINSIC mod
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: ierrX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      spmdX0 = mod(ORG_RANK,ORG_SIZE)
      spmdX1 = (128/ORG_SIZE+1)*spmdX0
      IF (spmdX0.LE.0) THEN
        spmd_startX0 = -spmdX1
      ELSE
        spmd_startX0 = 0
      ENDIF
      IF (spmdX0.LT.128/(128/ORG_SIZE+1)) THEN
        spmd_endX0 = 128/ORG_SIZE+0
      ELSE
        spmd_endX0 = 128-spmdX1
      ENDIF
      spmd_stepX0 = 1
      DO k=spmd_startX0,spmd_endX0,1
        DO j=1,129,1
          DO i=1,257,1
            a(i-1,j-1,k,0) = 0.0e0
            a(i-1,j-1,k,1) = 0.0e0
            a(i-1,j-1,k,2) = 0.0e0
            a(i-1,j-1,k,3) = 0.0e0
            b(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,0) = 0.0e0
            b(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,1) = 0.0e0
            b(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,2) = 0.0e0
            c(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,0) = 0.0e0
            c(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,1) = 0.0e0
            c(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,2) = 0.0e0
            p(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &) = 0.0e0
            wrk1(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE&
     &+1)) = 0.0e0
            bnd(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+&
     &1)) = 0.0e0
          ENDDO
        ENDDO
      ENDDO
      spmdX2 = mod(ORG_RANK,ORG_SIZE)
      spmdX3 = (128/ORG_SIZE+1)*spmdX2
      IF (spmdX2.LE.0) THEN
        spmd_startX1 = -spmdX3
      ELSE
        spmd_startX1 = 0
      ENDIF
      IF (spmdX2.LT.(kmax-1)/(128/ORG_SIZE+1)) THEN
        spmd_endX1 = 128/ORG_SIZE+0
      ELSE
        spmd_endX1 = kmax-1-spmdX3
      ENDIF
      spmd_stepX1 = 1
      DO k=spmd_startX1,spmd_endX1,1
        DO j=1,jmax,1
          DO i=1,imax,1
            a(i-1,j-1,k,0) = 1.0e0
            a(i-1,j-1,k,1) = 1.0e0
            a(i-1,j-1,k,2) = 1.0e0
            a(i-1,j-1,k,3) = (1.0e0)/(6.0e0)
            b(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,0) = 0.0e0
            b(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,1) = 0.0e0
            b(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,2) = 0.0e0
            c(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,0) = 1.0e0
            c(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,1) = 1.0e0
            c(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &,2) = 1.0e0
            p(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)&
     &) = (float(k*k+2*spmdX3*k+spmdX3*spmdX3))/(float(kmax*kmax-2*kmax+&
     &1))
            wrk1(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE&
     &+1)) = 0.0e0
            bnd(i-1,j-1,k+spmdX3-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+&
     &1)) = 1.0e0
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END SUBROUTINE
      SUBROUTINE jacobi(p,a,b,c,bnd,wrk1,wrk2,nn,gosa)
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: gosa
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: loop
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: i
      REAL(KIND=4):: s0
      REAL(KIND=4):: ss
      INTEGER(KIND=4):: k
      INTRINSIC max
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: wrk2(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: wrk1(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: bnd(0:256,0:128,0:128/ORG_SIZE)
      REAL(KIND=4):: c(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: b(0:256,0:128,0:128/ORG_SIZE,0:2)
      REAL(KIND=4):: a(0:256,0:128,0:128/ORG_SIZE,0:3)
      REAL(KIND=4):: p(0:256,0:128,-1:128/ORG_SIZE+1)
      INTRINSIC mod
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: ierrX0
      INTEGER(KIND=4):: localidX0
      INTEGER(KIND=4):: accessidX0
      INTEGER(KIND=4):: distX0
      INTEGER(KIND=4):: distX1
      INTEGER(KIND=4), ALLOCATABLE:: ireqX0(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX1(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX2(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX3(:)
      INTEGER(KIND=4):: ierrX1
      INTEGER(KIND=4):: statusX0(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX1(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX2(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX3(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      REAL(KIND=4), ALLOCATABLE:: sendlX0(:,:)
      REAL(KIND=4), ALLOCATABLE:: sendrX0(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvlX0(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvrX0(:,:)
      INTEGER(KIND=4):: indexX0
      INTEGER(KIND=4):: indexX1
      INTEGER(KIND=4):: indexX2
      INTEGER(KIND=4):: indexX3
      INTEGER(KIND=4):: indexX4
      INTRINSIC abs
      INTEGER(KIND=4):: lsizeX0
      INTRINSIC min
      INTEGER(KIND=4):: rsizeX0
      INTEGER(KIND=4):: ierrX2
      REAL(KIND=4):: gosaX0
      REAL(KIND=4):: recvbufX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      DO loop=1,nn,1
        gosa = 0.0e0
        CONTINUE
        ALLOCATE (ireqX0(0:ORG_SIZE-1),ireqX1(0:ORG_SIZE-1),ireqX2(0:ORG&
     &_SIZE-1),ireqX3(0:ORG_SIZE-1),sendlX0(1:33153,0:ORG_SIZE-1),sendrX&
     &0(1:33153,0:ORG_SIZE-1),recvlX0(1:33153,0:ORG_SIZE-1),recvrX0(1:33&
     &153,0:ORG_SIZE-1))
        localidX0 = mod(ORG_RANK,ORG_SIZE)
        DO indexX4=0,ORG_SIZE-1,1
          ireqX0(indexX4) = MPI_REQUEST_NULL
          ireqX2(indexX4) = MPI_REQUEST_NULL
          ireqX1(indexX4) = MPI_REQUEST_NULL
          ireqX3(indexX4) = MPI_REQUEST_NULL
        ENDDO
        DO indexX4=0,ORG_SIZE-1,1
          IF (localidX0.EQ.indexX4) CYCLE
          distX0 = abs(indexX4-localidX0)
          distX1 = indexX4-localidX0
          accessidX0 = ORG_RANK+distX1
          lsizeX0 = min(1-(128/ORG_SIZE+1)*(distX0-1),128/ORG_SIZE+1)
          rsizeX0 = min(1-(128/ORG_SIZE+1)*(distX0-1),128/ORG_SIZE+1)
          IF ((indexX4.GT.localidX0).AND.(lsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=128/ORG_SIZE+1-lsizeX0,128/ORG_SIZE,1
              DO indexX1=0,128,1
                DO indexX0=0,256,1
                  sendlX0(indexX3,indexX4) = p(indexX0,indexX1,indexX2)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendlX0(1,indexX4),33153*lsizeX0,MPI_REAL4,ac&
     &cessidX0,100,MPI_COMM_WORLD,ireqX0(indexX4),ierrX1)
          ENDIF
          IF ((indexX4.LT.localidX0).AND.(rsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=0,-1+rsizeX0,1
              DO indexX1=0,128,1
                DO indexX0=0,256,1
                  sendrX0(indexX3,indexX4) = p(indexX0,indexX1,indexX2)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendrX0(1,indexX4),33153*rsizeX0,MPI_REAL4,ac&
     &cessidX0,100,MPI_COMM_WORLD,ireqX1(indexX4),ierrX1)
          ENDIF
          IF ((indexX4.LT.localidX0).AND.(lsizeX0.GT.0)) CALL MPI_Irecv(&
     &recvlX0(1,indexX4),33153*lsizeX0,MPI_REAL4,accessidX0,100,MPI_COMM&
     &_WORLD,ireqX2(indexX4),ierrX1)
          IF ((indexX4.GT.localidX0).AND.(rsizeX0.GT.0)) CALL MPI_Irecv(&
     &recvrX0(1,indexX4),33153*rsizeX0,MPI_REAL4,accessidX0,100,MPI_COMM&
     &_WORLD,ireqX3(indexX4),ierrX1)
        ENDDO
        CALL MPI_Waitall(ORG_SIZE,ireqX0,statusX0,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX1,statusX1,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX2,statusX2,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX3,statusX3,ierrX1)
        DO indexX4=0,ORG_SIZE-1,1
          IF (localidX0.EQ.indexX4) CYCLE
          distX0 = abs(indexX4-localidX0)
          lsizeX0 = min(1-(128/ORG_SIZE+1)*(distX0-1),128/ORG_SIZE+1)
          rsizeX0 = min(1-(128/ORG_SIZE+1)*(distX0-1),128/ORG_SIZE+1)
          IF ((indexX4.LT.localidX0).AND.(lsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=-(128/ORG_SIZE+1)*(distX0-1)-lsizeX0,-1-(128/ORG_&
     &SIZE+1)*(distX0-1),1
              DO indexX1=0,128,1
                DO indexX0=0,256,1
                  p(indexX0,indexX1,indexX2) = recvlX0(indexX3,indexX4)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
          IF ((indexX4.GT.localidX0).AND.(rsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=128/ORG_SIZE+1+(128/ORG_SIZE+1)*(distX0-1),128/OR&
     &G_SIZE+(128/ORG_SIZE+1)*(distX0-1)+rsizeX0,1
              DO indexX1=0,128,1
                DO indexX0=0,256,1
                  p(indexX0,indexX1,indexX2) = recvrX0(indexX3,indexX4)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
        ENDDO
        DEALLOCATE (ireqX0,ireqX1,ireqX2,ireqX3,sendlX0,sendrX0,recvlX0,&
     &recvrX0)
        spmdX0 = mod(ORG_RANK,ORG_SIZE)
        spmdX1 = (128/ORG_SIZE+1)*spmdX0
        IF (spmdX0.LE.1/(128/ORG_SIZE+1)) THEN
          spmd_startX0 = 1-spmdX1
        ELSE
          spmd_startX0 = 0
        ENDIF
        IF (spmdX0.LT.(kmax-2)/(128/ORG_SIZE+1)) THEN
          spmd_endX0 = 128/ORG_SIZE+0
        ELSE
          spmd_endX0 = kmax-2-spmdX1
        ENDIF
        spmd_stepX0 = 1
        gosaX0 = gosa
        gosa = 0.0e0
        DO k=spmd_startX0,spmd_endX0,1
          DO j=2,jmax-1,1
            DO i=2,imax-1,1
              s0 = a(i-1,j-1,k,0)*p(i,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZ&
     &E))*(128/ORG_SIZE+1))+a(i-1,j-1,k,1)*p(i-1,j,k+spmdX1-(mod(ORG_RAN&
     &K,ORG_SIZE))*(128/ORG_SIZE+1))+a(i-1,j-1,k,2)*p(i-1,j-1,k+spmdX1+1&
     &-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1))+b(i-1,j-1,k+spmdX1-(mo&
     &d(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1),0)*(p(i,j,k+spmdX1-(mod(ORG&
     &_RANK,ORG_SIZE))*(128/ORG_SIZE+1))-p(i,j-2,k+spmdX1-(mod(ORG_RANK,&
     &ORG_SIZE))*(128/ORG_SIZE+1))-p(i-2,j,k+spmdX1-(mod(ORG_RANK,ORG_SI&
     &ZE))*(128/ORG_SIZE+1))+p(i-2,j-2,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))&
     &*(128/ORG_SIZE+1)))+b(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(1&
     &28/ORG_SIZE+1),1)*(p(i-1,j,k+spmdX1+1-(mod(ORG_RANK,ORG_SIZE))*(12&
     &8/ORG_SIZE+1))-p(i-1,j-2,k+spmdX1+1-(mod(ORG_RANK,ORG_SIZE))*(128/&
     &ORG_SIZE+1))-p(i-1,j,k+spmdX1-1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_&
     &SIZE+1))+p(i-1,j-2,k+spmdX1-1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SI&
     &ZE+1)))+b(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+&
     &1),2)*(p(i,j-1,k+spmdX1+1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1&
     &))-p(i-2,j-1,k+spmdX1+1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1))&
     &-p(i,j-1,k+spmdX1-1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1))+p(i&
     &-2,j-1,k+spmdX1-1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1)))+c(i-&
     &1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1),0)*p(i-2,&
     &j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1))+c(i-1,j-1,&
     &k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1),1)*p(i-1,j-2,k+&
     &spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1))+c(i-1,j-1,k+spmd&
     &X1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1),2)*p(i-1,j-1,k+spmdX1&
     &-1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1))+wrk1(i-1,j-1,k+spmdX&
     &1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE+1))
              ss = (s0*a(i-1,j-1,k,3)-p(i-1,j-1,k+spmdX1-(mod(ORG_RANK,O&
     &RG_SIZE))*(128/ORG_SIZE+1)))*bnd(i-1,j-1,k+spmdX1-(mod(ORG_RANK,OR&
     &G_SIZE))*(128/ORG_SIZE+1))
              gosa = gosa+ss*ss
              wrk2(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SI&
     &ZE+1)) = p(i-1,j-1,k+spmdX1-(mod(ORG_RANK,ORG_SIZE))*(128/ORG_SIZE&
     &+1))+omega*ss
            ENDDO
          ENDDO
        ENDDO
        CALL MPI_Allreduce(gosa,recvbufX0,1,MPI_REAL4,MPI_SUM,MPI_COMM_W&
     &ORLD,ierrX2)
        gosa = gosaX0+recvbufX0
        spmdX2 = mod(ORG_RANK,ORG_SIZE)
        spmdX3 = (128/ORG_SIZE+1)*spmdX2
        IF (spmdX2.LE.1/(128/ORG_SIZE+1)) THEN
          spmd_startX1 = 1-spmdX3
        ELSE
          spmd_startX1 = 0
        ENDIF
        IF (spmdX2.LT.(kmax-2)/(128/ORG_SIZE+1)) THEN
          spmd_endX1 = 128/ORG_SIZE+0
        ELSE
          spmd_endX1 = kmax-2-spmdX3
        ENDIF
        spmd_stepX1 = 1
        DO k=spmd_startX1,spmd_endX1,1
          DO j=2,jmax-1,1
            DO i=2,imax-1,1
              p(i-1,j-1,k) = wrk2(i-1,j-1,k)
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END SUBROUTINE
      FUNCTION gdtime(time)
      INCLUDE 'mpif.h'
      REAL(KIND=4):: gdtime
      REAL(KIND=4):: time(1:2)
      REAL(KIND=4):: ldtime(0:0)
      EXTERNAL dtime
      REAL(KIND=4):: dtime
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: UTL_tmp001
      INTEGER(KIND=4):: ierrX0
      INTRINSIC mod
      REAL(KIND=4):: ldtimeX0
      INTEGER(KIND=4):: ierrX1
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      UTL_tmp001 = dtime(time)
      IF (0.EQ.ORG_RANK) ldtime(mod(0,1)) = UTL_tmp001
      IF (ORG_RANK.EQ.0) ldtimeX0 = ldtime(mod(0,1))
      CALL MPI_Bcast(ldtimeX0,1,MPI_REAL4,0,MPI_COMM_WORLD,ierrX1)
      gdtime = ldtimeX0
      RETURN
      END FUNCTION
